%
% Controle de velocidade angular do motor eletrico CC
% controle PI 
%
% Utilizar os parametros no dominio continuo 's'
% obtidos na Exp. 3 ou os parametros obtidos
% na Exp. 4 mas convertidos para o tempo continuo:
% (a1,b1) --> (Kp,T)
% Lembre-se que os parametros (a1,b1) estimados na Exp. 4 so valem
% para fa=50Hz-->Ta=0.02s
% Convertendo inicialmente para o tempo continuo
% podemos posteriormente converte-lo para um modelo discreto
% com valor qq de Ta
Kw = 1.0;
T  = 0.25;
%
% Definicao do intervalo de amostragem
Ta = 0.02;
% Sistema definido no dominio continuo
Gs = tf([Kw],[T 1]);
% Conversao para o dominio discreto utilizando Ta
% Metodo de conversao Zero-th Order Hold
Gz = c2d(Gs,Ta,'zoh');
%
% Definicao do controlador PI H(z)=Kp(1+Ta/Ti*1/(z-1))
% Escolha de ganhos
%
Kp = 3; Ti=0.1; Hz=tf([Ti (Ta-Ti)],[Ti -Ti],Ta)
% Definicao da malha aberta
% Sao definidos 3 sistemas distintos
GHz = Kp*Hz*Gz;
display('Polos e zeros GHz')
pole(GHz)
zero(GHz)
%
% definicao da malha fechada
% realimentacao unitaria
%
cloop = feedback(GHz,1);
display('Polos e zeros cloop')
pole(cloop)
zero(cloop)
%
% Grafico da resposta a degrau no dominio de tempo discreto
%
tfinal = 5;
t = 0:Ta:tfinal;
figure(3);
stepplot(cloop,t);
grid on
print -dpng respostadegrauPI_projeto.png
%
% Caracteristicas da resposta a degrau
% Tr - Tempo de subida, Ts - Tempo de acomodacao, Mp - Maximo sobresinal
%
display('caracteristicas resposta a degrau cloop')
info=stepinfo(cloop)
