%
% Controle de velocidade angular do motor eletrico CC
% Influencia de Ta
%
Kw = 1.0;
T  = 0.25;
%
% Definicao dos intervalos de amostragem Ta
Ta1 = 0.02;
Ta2 = 0.05;
Ta3 = 0.1;
% Sistema definido no dominio continuo
Gs = tf([Kw],[T 1]);
%
% Conversao para o dominio discreto utilizando Ta1, Ta2 e ta3
% Metodo de conversao Zero-th Order Hold
%
Gz1 = c2d(Gs,Ta1,'zoh');
Gz2 = c2d(Gs,Ta2,'zoh');
Gz3 = c2d(Gs,Ta3,'zoh');
%
% Definicao do controlador PI H(z)=Kp(1+Ta/Ti*1/(z-1))
% Escolha de ganhos
%
% Utiliza-se o mesmo controlador PI para os tres sistemas
Kp = 3; Ti=0.1;
Hz1=tf([Ti (Ta1-Ti)],[Ti -Ti],Ta1)
Hz2=tf([Ti (Ta2-Ti)],[Ti -Ti],Ta2)
Hz3=tf([Ti (Ta3-Ti)],[Ti -Ti],Ta3)
% Definicao da malha aberta
% Sao definidos 3 sistemas distintos
GH1z = Kp*Hz1*Gz1;
GH2z = Kp*Hz2*Gz2;
GH3z = Kp*Hz3*Gz3;
display('Polos e zeros GH1z')
pole(GH1z)
zero(GH1z)
display('Polos e zeros GH2z')
pole(GH2z)
zero(GH2z)
display('Polos e zeros GH3z')
pole(GH3z)
zero(GH3z)
%
% definicao da malha fechada
% realimentacao unitaria
%
cloop1 = feedback(GH1z,1);
cloop2 = feedback(GH2z,1);
cloop3 = feedback(GH3z,1);
display('Polos e zeros cloop1')
pole(cloop1)
zero(cloop1)
display('Polos e zeros cloop2')
pole(cloop2)
zero(cloop2)
display('Polos e zeros cloop3')
pole(cloop3)
zero(cloop3)
%
% Grafico da resposta a degrau no dominio de tempo discreto
% E'necessario definir 3 vetores de tempo distintos
tfinal = 5;
t1 = 0:Ta1:tfinal;
t2 = 0:Ta2:tfinal;
t3 = 0:Ta3:tfinal;
stepplot(cloop1,t1);hold on
stepplot(cloop2,t2);hold on
stepplot(cloop3,t3);hold on
grid on
% salva a figura numm arquivo png
print -dpng respostadegrau_InfluenciaTa.png
% mapa de polos e zeros
figure(2)
pzmap(cloop1,cloop2,cloop3)
axis equal
print -dpng mapapolosezerosinfluenciaTa.png
%
% Caracteristicas da resposta a degrau
% Tr - Tempo de subida, Ts - Tempo de acomodacao, Mp - Maximo sobresinal
%
display('caracteristicas resposta a degrau cloop1')
info=stepinfo(cloop1)
display('caracteristicas resposta a degrau cloop2')
info=stepinfo(cloop2)
display('caracteristicas resposta a degrau cloop3')
info=stepinfo(cloop3)
